#version 120
#extension GL_ARB_shader_texture_lod : enable
#define MAX_COLOR_RANGE 48.0
/*
!! DO NOT REMOVE !!
BSL Shaders is derived from Chocapic13 v5 test 2

This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/

/*
Disable an effect by putting "//" before "#define" when there is no number after
You can tweak the numbers, the impact on the shaders is self-explained in the variable's name or in a comment
*/

//ADJUSTABLE VARIABLES//

	#define WorldDimension 0								//The world dimension you're in. -1 : Nether | 0 : Overworld | 1 : End [0 -1 1]
	#define Fog_Distance 8									//Set starting point for fog. Insert Minecraft's render distance here for best result. [2 4 6 8 10 12 14 16]
	#define Fog_Height 72.0									//Set vertical position for fog. Insert average ground height for best result. [8.0 16.0 24.0 32.0 40.0 48.0 56.0 64.0 72.0 80.0 88.0 96.0 104.0 112.0 120.0 128.0]
	
	//#define DynaWeather									//Enable dynamic weather.
		#define DynaWeather_Strength 0.4					//Change dynamic weather's transition range. [0.1 0.2 0.3 0.4 0.5 0.6]
		#define DynaWeather_Speed 1.0						//Change dynamic weather's transition speed. [0.25 0.5 1.0 2.0 4.0 8.0 16.0]
	
	#define Weather 										//Enables rain and snow.
		#define Weather_Opacity 0.4							//Set opacity of rain and snow [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]
	
	//#define DOFv2											//Enables blur effect with mixing method.
	
	#define Godrays											//Light shafts around sun and moon.
		#define Godrays_Strength 1.5						//Change godrays strength. [0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0]
		const float exposure = 3.0;
		const int NUM_SAMPLES = 5;
		const float raysize = 1.0;
		
	//#define VL											//World space light shafts.
		#define VL_Strength 1.0								//Set VL Intensity. [0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]

	//#define RoundSunMoon									//Enables round sun and moon. Disable sun and moon from video settings if required.
	
	#define Sky_OriginalColor								//Original BSL Shaders' sky color.
	//#define Sky_AlternativeColor							//Alternative sky color.
	//#define Sky_ClassicColor								//Older version of BSL Shaders' sky color.
	//#define Sky_BrightColor								//Brighter version of the original sky color.
	//#define Sky_VanilaColor								//Vanila/resourcepack based sky color.
	
	//#define RPSupport										//Enable resourcepack support for shaders, such as specular, bump mapping and POM.
		#define Specular_Strength 4.0
		
	#define ReflectWater									//Water creates screen space reflection.
	//#define ReflectPuddle									//Creates reflective rain puddle.
		//#define Reflect_Cloud								//Reflects cloud if not reflected from screen space reflection. Cloud must be enabled.
		#define Reflect_Strength 1.0						//Opacity of water reflection. [0.2 0.4 0.6 0.8 1.0]

	//#define Celshade										//Creates black outline.
		#define Celshade_Out								//Cel shading technique. Can enable both.
		//#define Celshade_In								//Cel shading technique. Can enable both.
		#define Celshade_Stroke 1.333						//Black outline stroke size. [0.666 1.000 1.333 1.666 2.000]
		#define Celshade_Strength 100.0						//Border detection strength. [10.0 25.0 50.0 100.0 200.0 500.0 1000.0 2000.0 5000.0]

	//#define BumpEdge
		#define BORDERE 2.0
		#define EDGESTR 0.25

	#define Cloud											//Creates cloud at the sky.
		#define Cloud_Strength 1.0							//Cloud Intensity [1.0 2.0 3.0]
		#define CLOUD_SPEED 1.0
		#define CLOUD_PASS 4
		#define CLOUD_DISTANCE 50
		#define CLOUD_HEIGHT 4
	#define Sky_Stars
	
	//#define Watercolor_Vanila								//Pure texture based water. Only enable one.
	//#define Watercolor_Clear								//Clear-ish water. Only enable one.
	//#define Watercolor_Tropical							//Weak green-ish water. Only enable one.
	//#define Watercolor_Legacy								//Strong blue water. Only enable one.
	//#define Watercolor_Classic							//Weak light blue water. Only enable one.
	#define Watercolor_Original								//Strong dark blue water. Only enable one.

	//#define WorldTimeAnimation
	#define AnimationSpeed 1.0								//Set shader's speed. [0.1 0.25 0.5 0.75 1.0 2.0 3.0 4.0]

//ADJUSTABLE VARIABLES//

const bool   gdepthMipmapEnabled  = true;

//don't touch these lines if you don't know what you do!
const int maxf = 4;				//number of refinements
const float stp = 1.2;			//size of one step for raytracing algorithm
const float ref = 0.1;			//refinement multiplier
const float inc = 2.2;			//increasement factor at each step

//ground constants (lower quality)
const int Gmaxf = 3;				//number of refinements
const float Gstp = 1.2;			//size of one step for raytracing algorithm
const float Gref = 0.11;			//refinement multiplier
const float Ginc = 3.0;			//increasement factor at each step

varying vec4 texcoord;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;

uniform ivec2 eyeBrightnessSmooth;

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

#ifdef DOFv2
uniform float centerDepthSmooth;
#endif

uniform sampler2D composite;
uniform sampler2D gaux1;
#ifdef RPSupport
uniform sampler2D gcolor;
uniform sampler2D gaux3;
#endif
uniform sampler2D gaux4;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gnormal;
uniform sampler2D gdepth;
uniform sampler2D noisetex;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 skyColor;
#ifdef Sky_VanilaColor
uniform vec3 fogColor;
#endif

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

uniform int isEyeInWater;
uniform int worldTime;
uniform float far;
uniform float near;
uniform float aspectRatio;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;

const float dimread = WorldDimension;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float matflag = texture2D(gaux1,texcoord.xy).g;

vec3 fragpos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0 - 1.0;

#ifdef WorldTimeAnimation
float frametime = worldTime/20.0*AnimationSpeed;
#else
float frametime = frameTimeCounter*AnimationSpeed;
#endif

#ifdef DynaWeather
float dynaweather = max(pow((sin(frametime*0.07*DynaWeather_Speed)*0.25+cos(frametime*0.03*DynaWeather_Speed+6)*0.25+0.5),1.5)*(DynaWeather_Strength+0.1)-0.1,0.0);
#else
float dynaweather = 0.0;
#endif
float weatherval = mix(rainStrength,1.0,dynaweather);

#ifdef Watercolor_Vanila
vec3 watercolor = vec3(0.02,0.08,0.28);
const float wateropacity = 0.2;
#endif

#ifdef Watercolor_Clear
vec3 watercolor = vec3(0.02,0.08,0.14);
const float wateropacity = 0.2;
#endif

#ifdef Watercolor_Tropical
vec3 watercolor = vec3(0.1,0.52,0.6);
const float wateropacity = 0.4;
#endif

#ifdef Watercolor_Legacy
vec3 watercolor = vec3(0.02,0.2,0.7);
const float wateropacity = 0.7;
#endif

#ifdef Watercolor_Classic
vec3 watercolor = vec3(0.1,0.4,0.9);
const float wateropacity = 0.4;
#endif

#ifdef Watercolor_Original
vec3 watercolor = vec3(0.03,0.07,0.12);
const float wateropacity = 0.8;
#endif

float time = float(worldTime);
float transition_fading = (clamp((time-12000.0)/500.0,0.0,1.0)-clamp((time-13500.0)/500.0,0.0,1.0) + clamp((time-22500.0)/500.0,0.0,1.0)-clamp((time-23500.0)/500.0,0.0,1.0));	//fading between sun/moon shadows
float night = clamp((time-13000.0)/500.0,0.0,1.0)-clamp((time-22500.0)/500.0,0.0,1.0);
float tB = abs(sin(time/12000*22/7));

float sky_lightmap = texture2D(gaux1,texcoord.xy).r;
float torch_lightmap = texture2D(gaux1,texcoord.xy).b;
float eBS = eyeBrightnessSmooth.y/240.0;
float iswet = wetness*pow(sky_lightmap,5.0)*sqrt(0.5+max(dot(normal,upVec),0.0));

#ifdef RPSupport
vec3 specular = pow(texture2D(gaux3,texcoord.xy).rgb,vec3(2.2));
float specmap = (specular.r+specular.g*(iswet));
#endif

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}

vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}

float cdist(vec2 coord) {
	return max(abs(coord.s-0.5),abs(coord.t-0.5))*2.0;
}

float edepth(vec2 coord) {
	return texture2D(depthtex0,coord).z;
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

#ifdef BumpEdge
float getdist(float rng) {
	return 1-clamp(ld(texture2D(depthtex0,texcoord.xy).r)/rng*far,0,1);
}
vec3 edgeshadow(vec3 clrr,float str) {
	//edge detect
	float d = edepth(texcoord.xy);
	float dtresh = 1/(far-near)/120.0;
	vec4 dc = vec4(d,d,d,d);
	vec4 sa;
	vec4 sb;
	float dist = (getdist(64)+1)/2;
	float bord = floor(BORDERE*viewWidth/1280) * dist;
	sa.x = edepth(texcoord.xy + vec2(-pw,-ph)*bord);
	sa.y = edepth(texcoord.xy + vec2(pw,-ph)*bord);
	sa.z = edepth(texcoord.xy + vec2(-pw,0.0)*bord);
	sa.w = edepth(texcoord.xy + vec2(0.0,ph)*bord);

	//opposite side samples
	sb.x = edepth(texcoord.xy + vec2(pw,ph)*bord);
	sb.y = edepth(texcoord.xy + vec2(-pw,ph)*bord);
	sb.z = edepth(texcoord.xy + vec2(pw,0.0)*bord);
	sb.w = edepth(texcoord.xy + vec2(0.0,-ph)*bord);

	vec4 dd = (2.0* dc - sa - sb) - dtresh;
	dd = vec4(step(dd.x,0.0),step(dd.y,0.0),step(dd.z,0.0),step(dd.w,0.0));

	float e = (clamp(dot(dd,vec4(0.25f,0.25f,0.25f,0.25f)),0.0,1.0));
	return clrr*(1-str)+clrr*e*str;
}
vec3 edgerim(vec3 clrr,float str) {
	//edge detect
	float d = edepth(texcoord.xy);
	float dtresh = 1/(far-near)/120.0;
	vec4 dc = vec4(d,d,d,d);
	vec4 sa;
	vec4 sb;
	float dist = (getdist(64)+1)/2;
	float bord = floor(BORDERE*viewWidth/1280) * dist;
	sa.x = edepth(texcoord.xy + vec2(-pw,-ph)*bord);
	sa.y = edepth(texcoord.xy + vec2(pw,-ph)*bord);
	sa.z = edepth(texcoord.xy + vec2(-pw,0.0)*bord);
	sa.w = edepth(texcoord.xy + vec2(0.0,ph)*bord);

	//opposite side samples
	sb.x = edepth(texcoord.xy + vec2(pw,ph)*bord);
	sb.y = edepth(texcoord.xy + vec2(-pw,ph)*bord);
	sb.z = edepth(texcoord.xy + vec2(pw,0.0)*bord);
	sb.w = edepth(texcoord.xy + vec2(0.0,-ph)*bord);

	vec4 dd = abs(2.0* dc - sa - sb) - (2.0* dc - sa - sb) - dtresh;
	dd = vec4(step(dd.x,0.0),step(dd.y,0.0),step(dd.z,0.0),step(dd.w,0.0));

	float e = (clamp(dot(dd,vec4(0.25f,0.25f,0.25f,0.25f)),0.0,1.0));
	return clrr*(1-e)*str;
}
#endif
vec3 getSkyColor(){
#ifdef Sky_OriginalColor
vec3 sky_color = vec3(0.15, 0.38, 1.0);
#endif
#ifdef Sky_AlternativeColor
vec3 sky_color = vec3(0.14, 0.27, 0.65);
#endif
#ifdef Sky_ClassicColor
vec3 sky_color = vec3(0.1, 0.35, 1.0);
#endif
#ifdef Sky_BrightColor
vec3 sky_color = vec3(0.15, 0.525, 1.25);
#endif
#ifdef Sky_VanilaColor
vec3 sky_color = pow(fogColor,vec3(2.2))*0.75;
#endif

return sky_color;
}

vec3 getSkyGradient(vec3 fposition) {
vec3 sky_color = vec3(0.0);
if (dimread == 0){
sky_color = getSkyColor();

vec3 nsunlight = normalize(pow(sunlight,vec3(2.2)))*2.0;
vec3 sVector = normalize(fposition);

float Lz = 1.0;
float cosT = dot(sVector,upVec);
float absCosT = pow(max(cosT,0.0),1.2);
float cosS = dot(sunVec,upVec);
float S = acos(cosS);
float cosY = dot(sunVec,sVector);
float absCosY = max(cosY,0.0);
float Y = acos(cosY);
float sF = pow(clamp(1-abs(cosT),0.0,0.9),2.5)*0.5;

float a = -1.0;
float b = -0.05;
float c = 2.0;
float d = -0.6;
float e = 0.1;

#ifdef Sky_AlternativeColor
sky_color = mix(sky_color,vec3(0.15,0.3,1.5),pow(1.0-abs(cosT),2.5));
sky_color = mix(sky_color,vec3(0.26,0.4,0.6),pow(1.0-abs(cosT),3.0));
b -= 0.025;
#endif
#ifdef Sky_BrightColor
b -= 0.04;
sF *= 0.9;
#endif
#ifdef Sky_VanilaColor
sF *= 0.22;
float vsmix = max(pow(max(cosT,0.0),0.9)-sF,0.0);
sky_color = mix(sky_color,pow(skyColor,vec3(2.2))*0.8,vsmix*(1-weatherval));
b -= 0.05;
#endif

vec3 sky_rain = vec3(0.25,0.3,0.4)*length(ambient_color)*pow(weatherval,1.5)*pow(1.0-absCosT*0.25*weatherval,4.0)*0.7;
sky_color = mix(sky_color*(1-pow(weatherval,2.0)*0.05),sky_rain,pow(weatherval,2.0));

//sun sky color
float L = (1+a*exp(b/(absCosT+0.01)))*(1+c*exp(d*Y)+e*absCosY*absCosY) + sF*(1-transition_fading);
L = pow(L,1.0-weatherval)+sF*weatherval/2*(1-transition_fading); //modulate intensity when raining
float skymix = clamp(sF*(1+absCosY*(tB-1.0))*(0.2+0.3*tB)+pow(absCosY,1.0+tB*7.0)*(1.0-tB)*pow(1-abs(cosT),0.5)*0.8,0.0,1.0)*(1-weatherval);
float skymult = clamp(pow(1-skymix*(1-tB)*(1-absCosT),0.75)+sF*(1-absCosY)*(0.45+0.45*tB),0.0,1.0+0.25*tB);
vec3 skyColorSun = mix(sky_color*skymult, nsunlight*skymix,skymix)*(L*(1-cosY*cosY/2*transition_fading*(1-weatherval)))*0.5*(1.0-pow(max(cosY,0.0),2.2)*0.4*(1.0-weatherval));
skyColorSun *= sunVisibility * (1-transition_fading*0.2);

//moon sky color
float McosS = MdotU;
float MS = acos(McosS);
float McosY = dot(moonVec,sVector);
float MY = acos(McosY);

float L2 = (1+a*exp(b/(absCosT+0.01)))*(1+c*exp(d*MY)+e*McosY*McosY)+0.2;
L2 = pow(L2,1.0-weatherval*0.8)*(1.0-weatherval*0.2); //modulate intensity when raining
vec3 skyColormoon = mix(moonlight,normalize(vec3(0.25,0.3,0.4))*length(moonlight),weatherval*0.8)*L2*0.8;
skyColormoon *= moonVisibility;

sky_color = min(vec3(1),skyColormoon*2.0+skyColorSun);
sky_color *= pow(2.0-(eBS*(1-isEyeInWater)+isEyeInWater),1.5-0.5*eBS)*(1-weatherval)+weatherval;
//sky_color = vec3(Lc);
}

if (dimread == -1) sky_color = vec3(0.0005,0.00025,0.00012);
if (dimread == 1) sky_color = vec3(0.006,0.005,0.006);
return sky_color;
}

vec3 getFogGradient(vec3 fposition){
vec3 fog_color = vec3(0.0);

if (dimread == 0){
fog_color = getSkyColor();
vec3 nsunlight = normalize(pow(sunlight,vec3(2.2)));
vec3 sVector = normalize(fposition);
float absCosT = max(dot(sVector,upVec),0.0);
float cosY = dot(sunVec,sVector);

float fogmix = pow(max(cosY,0.0),2.0+tB)*(1.0-pow(tB,0.5));
vec3 fogColorDay = mix(fog_color*(1-fogmix*(1.0-tB)),nsunlight,fogmix)*sunVisibility*(1-transition_fading*0.2);
vec3 fogColorNight = moonlight;
fog_color = fogColorDay + fogColorNight*2.0;
vec3 fogColorRain = vec3(0.25,0.3,0.4)*length(ambient_color)*pow(weatherval,1.5)*0.5;
fog_color = mix(fog_color*(1-pow(weatherval,2.0)*0.05),fogColorRain,pow(weatherval,2.0))*(1-absCosT*0.8);

}

if (dimread == -1) fog_color = vec3(0.0005,0.00025,0.00012);
if (dimread == 1) fog_color = vec3(0.006,0.005,0.006);

return fog_color;
}

vec3 getVLGradient(vec3 fposition){
vec3 fog_color = getSkyColor();
vec3 nsunlight = normalize(pow(sunlight,vec3(2.2)))*(2.0);
vec3 sVector = normalize(fposition);
float absCosT = max(dot(sVector,upVec),0.0);
float cosY = dot(sunVec,sVector);

float fogmix = pow(max(cosY,0.0),2.0+2.0*tB);
vec3 fogColorDay = mix(fog_color*(1-fogmix*(1.0-tB)),nsunlight,fogmix)*sunVisibility*(1-transition_fading*0.2);
vec3 fogColorNight = moonlight;
fog_color = fogColorDay + fogColorNight*2.0;
vec3 fogColorRain = vec3(0.25,0.3,0.4)*length(ambient_color)*pow(weatherval,1.5)*0.5;
fog_color = mix(fog_color*(1-pow(weatherval,2.0)*0.05),fogColorRain,pow(weatherval,2.0))*(1-absCosT*0.8);

return fog_color;
}


vec3 drawSun(vec3 fposition,vec3 color,vec3 mult) {
vec3 sVector = normalize(fposition);

float angle = (1-max(dot(sVector,sunVec),0.0))*500.0*(1+weatherval);
float sun = exp(-angle*angle);
sun *= (1-rainStrength)*clamp(sunVisibility+transition_fading*(1-rainStrength)/2,0,1);

vec3 lc = pow(sunlight,vec3(2.2))*(2-transition_fading)/2;
float sunmult = pow(128.0,(1-rainStrength))*pow(sun,0.1);

vec3 suncol = lc*sunmult*mix(mult,vec3(1),sun*0.05);
return clamp(mix(color,suncol,sun*(1-rainStrength)),vec3(0),vec3(MAX_COLOR_RANGE));

}

vec3 drawMoon(vec3 fposition,vec3 color,vec3 mult) {
vec3 sVector = normalize(fposition);

float angle = (1-max(dot(sVector,moonVec),0.0))*300.0*(1+weatherval);
float moon = exp(-angle*angle);
moon *= (1-rainStrength)*clamp(moonVisibility+transition_fading*(1-rainStrength)/2,0,1);
moon = clamp(moon*moon*moon*moon,0,1)+moon/10;
vec3 lc = moonlight*(2.0-transition_fading)*60.0;

vec3 mooncol = pow(lc,vec3(1.0/1.2))*32*mix(mult,vec3(1),moon*0.05);
return clamp(mix(color,mooncol,moon*(1-rainStrength)),vec3(0),vec3(MAX_COLOR_RANGE));

}



vec3 calcFog(vec3 pos, vec3 color, vec3 fogclr) {
	float start = Fog_Distance*(6.0-3.0*weatherval)*(1-night);
	float range = Fog_Distance*96.0*(1-night*0.75);
	float fog = 1.0-clamp(length(pos)/range-start/range,0.0,1.0);
	fog = 1.0-((1.0-fog)*(eBS*(1-isEyeInWater)+isEyeInWater));

	return mix(fogclr,color,fog);
}
vec3 calcConstFog2(vec3 pos, vec3 pos0, vec3 color, vec3 fogclr) {
	float start = Fog_Distance*(6.0-3.0*weatherval)*(1-night);
	float range = Fog_Distance*96.0*(1-night*0.75);
	float fog = 1.0-clamp(length(pos)/range-start/range,0.0,1.0);
	float fog0 = 1.0-clamp(length(pos0)/range-start/range,0.0,1.0);
	fog = 1.0-((1.0-fog)*(eBS*(1-isEyeInWater)+isEyeInWater));
	fog0 = 1.0-((1.0-fog0)*(eBS*(1-isEyeInWater)+isEyeInWater));
	
	return mix(fogclr,color + fogclr*(1-fog),fog0);
}
vec3 calcSkyFog(vec3 pos, vec3 color, vec3 fogclr) {
	float density = 1500.0 *(1.0 + weatherval);
	float start = 0.02;
	float rainFog = 1.0+weatherval;
	float fog = min(exp(-length(pos)/density/(sunVisibility*0.7+0.3)*rainFog)+start*sunVisibility*(1-weatherval),1.0);

	vec3 fc = fogclr*1.5;
	return mix(fc,color,fog);
}
vec3 calcSkyInWaterFog(vec3 pos, vec3 color, vec3 fogclr) {
	float density = 1500.0 *(1.0 + weatherval);
	float start = 0.02;
	float rainFog = 1.0+weatherval;
	float fog = min(exp(-length(pos)/density/(sunVisibility*0.7+0.3)*rainFog)+start*sunVisibility*(1-weatherval),1.0);

	vec3 fc = fogclr*3.0;
	return mix(fc,color*2,fog);
}
vec3 underwaterFog (vec3 pos,vec3 color, vec3 Ucolor,float opacity) {
	float o = clamp(opacity*1.5,0.1,1.0);
	vec3 fc = Ucolor*(1.0-0.9*eBS);
	float start = 2.0/o*Fog_Distance/8;
	float range = 30.0/o*Fog_Distance/8;
	float fog = clamp(length(pos)/range-start/range,0.0,1.0);

	vec3 c = mix(color,color*pow(Ucolor,vec3(2.2)),fog);
	fc *= 0.2;
	return mix(c,fc,fog);
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));
}

vec3 drawCloud(vec3 fposition,vec3 color, float str) {
float totalcloud = 0;
vec3 sVector = normalize(fposition);
float cosT = dot(sVector,upVec);
float cosS = dot(sunVec,sVector);
float pi = 3.1415927;
vec2 wind = vec2(-frametime,frametime)/15000*CLOUD_SPEED;

vec3 tpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0));
vec3 wVector = normalize(tpos);

vec3 cloud_color = (sunlight*sunVisibility+moonlight*8.0)*2.0;
vec3 cloud_color_rain = mix(vec3(0.22,0.24,0.32),vec3(0.025,0.035,0.048),moonVisibility)*2;
cloud_color = mix(cloud_color*(1-pow(weatherval,1.0+4.0*weatherval)),cloud_color_rain*(2.0-weatherval),pow(weatherval,1.5))*(4-3*eBS);

for (int i = 0; i < CLOUD_PASS; i++) {
	vec3 intersection = wVector*((CLOUD_DISTANCE-i*CLOUD_HEIGHT/CLOUD_PASS)/(wVector.y));
	vec3 wpos = tpos.xyz;
	vec2 coord1 = (intersection.xz)/50000 + cameraPosition.xz/75000;
	vec2 coord = sin(coord1.yx);
	float noise = texture2D(noisetex,coord*pow(2,pow(5.0,1.0/64.0))+wind*pow(2.0,0.0)).x*8;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,4.0/64.0))+wind*pow(2.0,0.25)).x*7;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,9.0/64.0))+wind*pow(2.0,0.5)).x*6;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,16.0/64.0))+wind*pow(2.0,0.75)).x*5;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,25.0/64.0))+wind*pow(2.0,1.0)).x*4;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,36.0/64.0))+wind*pow(2.0,1.25)).x*3;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,49.0/64.0))+wind*pow(2.0,1.5)).x*2;
		  noise+= texture2D(noisetex,coord*pow(2,pow(5.0,64.0/64.0))+wind*pow(2.0,1.75)).x;
		  noise = (pow(noise/36.0,0.225) - (1.0-(1.05-0.1*sin(i/4*pi))/6.0)*pow(1-weatherval*0.7,0.5))*(mix(6.0,2.0,weatherval));

	float cloud2 = max(noise,0.0)*0.1;
	totalcloud = mix(totalcloud,1-i/(CLOUD_PASS+1),cloud2);
	cloud_color = mix(cloud_color,vec3(0),(cloud2*10)*pow(float(i/CLOUD_PASS),2.2));
}
totalcloud /= CLOUD_PASS;
totalcloud = pow(totalcloud*10.0,2.0)*0.4;
totalcloud*= pow(clamp(cosT,0.0,1.0/(2.0-weatherval))*(2.0-weatherval),2.0-weatherval*0.7);

float rainl = pow(abs(cosS),8.0)*2*weatherval;
cloud_color = mix(cloud_color,cloud_color*1.5,rainl)*mix(str,1.0,weatherval);

vec3 c = mix(color,cloud_color*Cloud_Strength,totalcloud);

return c;
}

vec3 drawStar(vec3 fposition,vec3 color) {

vec3 sVector = normalize(fposition);
float cosT = max(dot(normalize(sVector),upVec),0.0);
float McosY = MdotU;
float cosY = SdotU;
vec3 tpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0));
vec3 wvec = normalize(tpos);
vec3 wVector = normalize(tpos);

vec4 totalcloud = vec4(.0);

vec3 intersection = wVector*((-cameraPosition.y+400.0)/(wVector.y));
vec3 iSpos = (gbufferModelView*vec4(intersection,1.0)).rgb;
float cosT2 = max(dot(normalize(iSpos),upVec),0.0);
vec2 wind = vec2(frametime/10000);

	intersection = wVector*((-cameraPosition.y+300.0*3.66*(1+cosT2*cosT2*3.5)+500*sqrt(cosT2))/(wVector.y)); 			//curved cloud plane
	vec3 wpos = tpos.xyz+cameraPosition;
	vec2 coord1 = intersection.xz/400000.0+wind*0.01;
	vec2 coord = fract(coord1);

	float noise = texture2D(noisetex,coord*32).x;
	noise += texture2D(noisetex,coord*32+vec2(250)).x;
	noise += texture2D(noisetex,coord*32+vec2(500)).x;
	noise += texture2D(noisetex,coord*32+vec2(750)).x;
	noise = clamp(1-noise*7,0,1);

	float starglow = texture2D(noisetex,coord+wind/50).x;
	starglow += texture2D(noisetex,coord/4-wind/50).x;
	starglow = clamp(starglow*starglow-1,0,1);

	totalcloud += vec4(moonlight*16*(1+starglow),noise);
	totalcloud.a = min(totalcloud.a,1.0);

totalcloud *= clamp(cosT*1.5,0,1)*2;
return mix(color.rgb,totalcloud.rgb*(1 - weatherval*0.8)*4.6,totalcloud.a*pow(cosT2,1.2)*moonVisibility*pow(1-weatherval,3.0)*(1-transition_fading));

}

float getPuddle(vec3 fposition){

float puddle = 0;
vec3 wpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0))+cameraPosition.xyz;
float pdwet = wetness*pow(sky_lightmap,8.0)*max(dot(normal,upVec),0.0);

puddle += texture2D(noisetex,wpos.xz/1024).r;
puddle += texture2D(noisetex,wpos.xz/2048).r*2;
puddle += texture2D(noisetex,wpos.xz/4096).r*3;
puddle += texture2D(noisetex,wpos.xz/8192).r*4;

puddle = pow(clamp(puddle*0.1-0.4,0.0,1.0)*(10.0/6.0),1.2);

puddle = puddle*weatherval*pdwet;

return puddle;
}

vec4 raytrace(vec3 fragpos, vec3 normal,vec3 fogclr, vec3 sky_int) {
    vec4 color = vec4(0.0);
    vec3 start = fragpos;
    vec3 rvector = normalize(reflect(normalize(fragpos), normalize(normal)));
    vec3 vector = stp * rvector;
    vec3 oldpos = fragpos;
    fragpos += vector;
	vec3 tvector = vector;
    int sr = 0;
    for(int i=0;i<40;i++){
        vec3 pos = nvec3(gbufferProjection * nvec4(fragpos)) * 0.5 + 0.5;
        if(pos.x < 0 || pos.x > 1 || pos.y < 0 || pos.y > 1 || pos.z < 0 || pos.z > 1.0) break;
        vec3 spos = vec3(pos.st, texture2D(depthtex1, pos.st).r);
        spos = nvec3(gbufferProjectionInverse * nvec4(spos * 2.0 - 1.0));
        float err = abs(length(fragpos.xyz-spos.xyz));
		if(err < pow(length(vector)*1.85,1.15)){

                sr++;
                if(sr >= maxf){
                    float border = clamp(1.0 - pow(cdist(pos.st), 20.0), 0.0, 1.0);
                    color = texture2D(composite, pos.st);
					float land = texture2D(gaux1, pos.st).g;
					land = float(land < 0.03);
					spos.z = mix(fragpos.z,2000.0*(0.4+clamp(sunVisibility+moonVisibility,0,1)*0.6),land);
					
					#ifdef Cloud
					if (land > 0.1){
						#ifdef Reflect_Cloud
						color.rgb = drawCloud(sky_int,calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr),2);
						#else
						color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
						#endif
						}
					else color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
					#else
					color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
					#endif

					color.a = 1.0;
                    color.a *= border;
                    break;
                }
				tvector -=vector;
                vector *=ref;
		}
        vector *= inc;
        oldpos = fragpos;
        tvector += vector;
		fragpos = start + tvector;
    }
    return color;
}

vec3 skyGradient (vec3 fposition, vec3 color, vec3 fogclr) {
	return (fogclr*3.+color)/4.;
}

vec4 raytraceGround(vec3 fragpos, vec3 normal,vec3 fogclr, vec3 sky_int) {
    vec4 color = vec4(0.0);
    vec3 start = fragpos;
    vec3 rvector = normalize(reflect(normalize(fragpos), normalize(normal)));

    vec3 vector = Gstp * rvector;

    vec3 oldpos = fragpos;
    fragpos += vector;
	vec3 tvector = vector;
    int sr = 0;

	  for(int i=0;i<30;i++){
        vec3 pos = nvec3(gbufferProjection * nvec4(fragpos)) * 0.5 + 0.5;
		if(pos.x < 0 || pos.x > 1 || pos.y < 0 || pos.y > 1 || pos.z < 0 || pos.z > 1.0) break;
        vec3 spos = vec3(pos.st, texture2D(depthtex1, pos.st).r);
        spos = nvec3(gbufferProjectionInverse * nvec4(spos * 2.0 - 1.0));
        float err = distance(fragpos.xyz,spos.xyz);
         if(err < pow(length(vector)*pow(length(tvector),0.11),1.1)*1.1){

                sr++;
                if(sr >= maxf){
                    float border = clamp(1.0 - pow(cdist(pos.st), 20.0), 0.0, 1.0);
                    color = texture2D(composite, pos.st);
					float land = texture2D(gaux1, pos.st).g;
					land = float(land < 0.03);
					spos.z = mix(fragpos.z,2000.0*(0.4+clamp(sunVisibility+moonVisibility,0,1)*0.6),land);

					#ifdef Cloud
					if (land > 0.1){
						#ifdef Reflect_Cloud
						color.rgb = drawCloud(sky_int,calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr),2);
						#else
						color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
						#endif
						}
					else color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
					#else
					color.rgb = calcFog(spos.xyz,pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE,fogclr);
					#endif

					color.a = 1.0;
                    color.a *= border*(1.0-land);
                    break;
                }
				tvector -=vector;
                vector *=Gref;


}
        vector *= Ginc;
        oldpos = fragpos;
        tvector += vector;
		fragpos = start + tvector;
    }
    return color;
}

//////////////////////////////VOID MAIN//////////////////////////////

void main() {
	vec4 color = texture2D(composite,texcoord.xy);
	
	int land = int(matflag < 0.03);
	int iswater = int(matflag > 0.04 && matflag < 0.07);
	int reflectable = int(matflag > 0.08 && matflag < 0.12);
	int reflectopaque = int(matflag > 0.14 && matflag < 0.17);
	int ismetal = int(matflag > 0.48 && matflag < 0.52);
	int emissive = int(matflag > 0.58 && matflag < 0.62);
	int emissivecolored = int(matflag > 0.61 && matflag < 0.65);
	int islava = int(matflag > 0.67 && matflag < 0.69);
	int hand  = int(matflag > 0.78 && matflag < 0.82);
	int particle  = int(matflag > 0.68 && matflag < 0.72);

	fragpos = nvec3(gbufferProjectionInverse * nvec4(fragpos * 2.0 - 1.0));
	vec3 fogpos  = nvec3(gbufferProjectionInverse * nvec4(vec3(texcoord.xy,texture2D(depthtex1,texcoord.xy).x) * 2.0 - 1.0));
	vec3 fogpos0  = fragpos.xyz;
	float cosT = dot(normalize(fragpos),upVec);
	float tB = abs(sin(time/12000*22/7));
	
	vec2 newtc = texcoord.xy;
	vec2 refract = texture2D(gdepth,texcoord.xy).gb*2.0-1.0;
	if (iswater > 0.9 && isEyeInWater < 0.9) newtc += refract;
	float refractflag = texture2D(gaux1,newtc.xy).g;
	int refractmask = int(refractflag > 0.04 && refractflag < 0.07);
	if (refractmask > 0.9) color.rgb = texture2D(composite,newtc.xy).rgb;
	
	color.rgb = pow(color.rgb,vec3(2.2))*MAX_COLOR_RANGE;
	float ao = texture2DLod(gdepth,texcoord.xy,1).a;
	color.rgb *= ao;
	vec3 craw = color.rgb;
	
	float wldsky = abs(dimread);
	
	vec3 skyclr = getSkyGradient(fragpos.xyz);
	vec3 fogclr = getFogGradient(fragpos.xyz);
	
	fogpos.z = mix(fogpos.z,2000.0*(0.25+sunVisibility*0.75),land);
	fogpos0.z = mix(fogpos0.z,2000.0*(0.25+sunVisibility*0.75),land);
	float normalDotEye = dot(normal, normalize(fragpos));
	float fresnel = pow(1.0 + normalDotEye, 5.0);
	fresnel = clamp(fresnel*0.98+0.02,0,1);
	
	vec3 lc = mix(vec3(0.0),sunlight*2.0,sunVisibility)+mix(vec3(0.0),pow(moonlight,vec3(0.75))*160,moonVisibility);
	vec4 reflection = vec4(0.0);
	
	vec3 npos = normalize(fragpos);
	vec3 reflectedVector = reflect(normalize(fragpos), normalize(normal));
	reflectedVector = fragpos + reflectedVector * (2000.0-fragpos.z);
	
	vec3 skyc = getSkyGradient(reflectedVector);
	vec3 sky_color = calcFog(reflectedVector,vec3(0),skyc)*clamp(sky_lightmap*16.0-12.0,0.0,1.0);
	#ifdef Cloud
	#ifdef Reflect_Cloud
	sky_color = mix(sky_color,drawCloud(reflectedVector,sky_color,2),clamp(sky_lightmap*16.0-12.0,0.0,1.0));
	#endif
	#endif

	if (isEyeInWater == 0){
		if (iswater > 0.9) {
			lc *= mix(vec3(1.0),vec3(1.0,0.8,0.5),sunVisibility);
			#ifdef ReflectWater
			reflection = raytrace(fragpos,normal,skyc,reflectedVector);
			#endif
			reflection.rgb = clamp(mix(sky_color, reflection.rgb, reflection.a)+(color.a)*lc*pow(1.0-weatherval,4)*128.0,vec3(0),vec3(1024));
			reflection.a = min(reflection.a,1.0);
			color.rgb = mix(color.rgb,reflection.rgb,fresnel*Reflect_Strength);
			}
		if (land < 0.9 && hand < 0.1 && particle < 0.1) {
			#ifdef ReflectPuddle
			float refpuddle = getPuddle(fragpos);
			if (refpuddle*fresnel > 0.001) reflection = raytraceGround(fragpos, normal, skyc,reflectedVector);
			reflection.rgb = mix(sky_color, reflection.rgb, reflection.a);
			color.rgb = mix(color.rgb*(1.0-pow(min(refpuddle,0.3)*(10.0/3.0),0.5)*0.4)+watercolor*wateropacity*pow(refpuddle,2.0)*0.1,reflection.rgb*1.3,fresnel*pow(refpuddle,0.5));
			color.rgb += pow(color.a,1.0+refpuddle*15.0)*refpuddle*lc*(1.0-weatherval)*(16.0-15.0*weatherval);
			#endif
			
			#ifdef RPSupport
			if (specmap*fresnel > 0.001) reflection = raytraceGround(fragpos, normal, skyc,reflectedVector);
			float rspecmap = specmap;
			#ifdef ReflectPuddle
			rspecmap = max(rspecmap*(1.0-pow(refpuddle,0.5)*3.0),0.0);
			#endif
			reflection.rgb = mix(sky_color, reflection.rgb, reflection.a);
			if (ismetal > 0.9){
				reflection.rgb = mix(reflection.rgb,vec3(length(reflection.rgb)),0.4)*color.rgb*8.0;
				lc = pow(lc,vec3(0.3))*pow(texture2D(gcolor,texcoord.xy).rgb,vec3(2.2))*8.0;
				}
			if (reflectable > 0.9) lc *= 0.6;
			color.rgb = mix(color.rgb,reflection.rgb,rspecmap*fresnel*(1.0-reflectopaque));
			color.rgb += pow(color.a,3.0)*lc*specmap*(1.0-weatherval)*(1.0+3.0*moonVisibility)*Specular_Strength;
			#endif
			}
		}
	
	float wcmask = length(fogpos-fogpos0);
	if (isEyeInWater == 0){
		if (hand < 0.9){
			if (land < 0.9 && matflag < 0.98){
				if (reflectable < 0.9) color.rgb = calcFog(fogpos0,color.rgb,fogclr);
				if (reflectable > 0.9){
					color.rgb = calcConstFog2(fogpos,fogpos0,color.rgb,fogclr);
				}
				
			}
			else
			{
				color.rgb = calcSkyFog(fogpos,color.rgb,skyclr);
				if (isEyeInWater < 0.9) color.rgb = color.rgb + (color.rgb*color.rgb - 0.008)*0.7*(1-night);
				if (wldsky < 0.1){
					#ifdef Cloud
					if (cosT > 0 && land > 0.9) color.rgb = drawCloud(fragpos.xyz,color.rgb,1);
					#endif
					#ifdef Sky_Stars
					if (cosT > 0 && land > 0.9) color.rgb = drawStar(fragpos.xyz,color.rgb);
					#endif
					#ifdef RoundSunMoon
					if (land > 0.9) {
					color.rgb = drawSun(fragpos,color.rgb,vec3(1));
					color.rgb = drawMoon(fragpos,color.rgb,vec3(1));
					}
					#endif
				}
			}
		}
	}
	
	if (isEyeInWater == 1 || reflectable > 0.9){
		if (wcmask > 128){
			#ifdef Cloud
			if (cosT > 0 && wldsky < 0.1) color.rgb = drawCloud(fragpos.xyz*10000,color.rgb,min((wcmask-128)/128,1.0)*0.25*eBS);
			#endif
			#ifdef Sky_Stars
			if (cosT > 0) color.rgb = color.rgb*0.9 + drawStar(fragpos.xyz*10000,color.rgb)*0.1;
			#endif
			#ifdef RoundSunMoon
			color.rgb = drawSun(fragpos*10000,color.rgb,pow(craw,vec3(0.5))*32);
			color.rgb = drawMoon(fragpos*10000,color.rgb,craw*512);
			#endif
		}
	}
	if (isEyeInWater == 1){
		if (iswater > 0.9 || reflectable > 0.9) color.rgb = calcSkyInWaterFog(fogpos,color.rgb,skyclr);
		if (land > 0.9) color.rgb = pow(watercolor,vec3(1.0/2.2));
		color.rgb = underwaterFog(fragpos,color.rgb,watercolor,wateropacity);
	}
	
	#ifdef Celshade
	float celborder = ceil(Celshade_Stroke*viewWidth/1280);
	float cdepth = clamp(ld(texture2D(depthtex0,texcoord.xy).r)/256*far,0,1)*4;
	
	float cdepthmask = 0;
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(pw*celborder,0)).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(-pw*celborder,0)).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(0,ph*celborder)).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(0,-ph*celborder)).r)/256*far,0,1);
	float cdepthmask2 = 0;
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(pw*celborder,ph*celborder)*0.66).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(pw*celborder,-ph*celborder)*0.66).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(-pw*celborder,ph*celborder)*0.66).r)/256*far,0,1);
	cdepthmask += clamp(ld(texture2D(depthtex0,texcoord.xy+vec2(-pw*celborder,-ph*celborder)*0.74).r)/256*far,0,1);
	cdepthmask = mix(cdepthmask,cdepthmask2,0.5);

	#ifdef Celshade_Out
	float cdeptho = (cdepth-cdepthmask);
	cdeptho = clamp(cdeptho,0,1/Celshade_Strength)*Celshade_Strength;
	cdeptho *= exp(-length(fragpos.xyz)/200)*(1-land)+land;
	cdeptho = 1-cdeptho;
	color.rgb = color.rgb*(isEyeInWater*0.7+cdeptho*(1-isEyeInWater*0.7)) + vec3(0.001);
	#endif

	#ifdef Celshade_In
	float cdepthi = (cdepthmask-cdepth);
	cdepthi = clamp(cdepthi,0,1/Celshade_Strength)*Celshade_Strength;
	cdepthi *= exp(-length(fragpos.xyz)/200)*(1-land)+land;
	cdepthi = 1-cdepthi;
	color.rgb = color.rgb*(isEyeInWater*0.7+cdepthi*(1-isEyeInWater*0.7)) + vec3(0.001);
	#endif

	#endif
	
	#ifdef BumpEdge
	vec3 nobump = color.rgb;
	float isbump = hand + land*(1-weatherval);
	float bumpfog = 1-(exp(-pow(ld(texture2D(depthtex0, texcoord.st).r)/4*far,4.0)*4.0));
	float bumpfog2 = 1-(exp(-pow(ld(texture2D(depthtex0, texcoord.st).r)/128*far,4.0)*4.0));
	bumpfog = clamp(bumpfog - bumpfog2 + isbump,0,1);
	float bumpstr = EDGESTR;
	if (iswater < 0.9 && islava < 0.9){
	color.rgb = edgeshadow(color.rgb,bumpstr);
	color.rgb = color.rgb + edgerim(color.rgb,bumpstr) * (1+torch_lightmap);
	}

	color.rgb = color.rgb*bumpfog + nobump.rgb*(1-bumpfog);
	//color.rgb = color.rgb*0 + bumpfog;
	#endif
	
	#ifdef Weather
	vec4 rain = pow(texture2D(gaux4,texcoord.xy),vec4(vec3(2.2),0.4));
	color.rgb = mix(color.rgb,(color.rgb+0.025)*1.025,rain.a*(1-hand)*(Weather_Opacity*0.2+length(color.rgb)*4*Weather_Opacity));
	#endif
	
	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
	tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 pos1 = tpos.xy/tpos.z;
	vec2 lightPos = pos1*0.5+0.5;
	float gr = 0.0;
	
	float distx = texcoord.x*aspectRatio-lightPos.x*aspectRatio;
	float disty = texcoord.y-lightPos.y;
	float illuminationDecay = pow(max(1.0-sqrt((distx*distx)/raysize+(disty*disty)/raysize),0.0),2.0);
	float truepos = sunPosition.z/abs(sunPosition.z);		//1 -> sun / -1 -> moon
	
if (dimread == 0 && isEyeInWater == 0){
	#ifdef Godrays
		vec3 rainc = mix(vec3(1.),fogclr*1.5,weatherval);
		vec3 lightColor = mix(sunlight*sunVisibility*rainc,pow(moonlight*(15.0-10.0*weatherval)*(0.3+0.7*tB),vec3(0.8))*moonVisibility*rainc,(truepos+1.0)/2.)/2;
		lightColor = mix(lightColor,vec3(length(lightColor))*(1.0+7.0*pow(weatherval,2.0)),weatherval);
		float centerdist = max((1-cdist(lightPos)*0.5),0.0);
		const int nSteps = NUM_SAMPLES;
		const float blurScale = 0.04/nSteps;
		vec3 blur = vec3(0.0);

		vec2 deltaTextCoord = (texcoord.st - lightPos.xy)*blurScale;
		vec2 textCoord = texcoord.st + deltaTextCoord;
		
		if (illuminationDecay > 0){
			for(int i=0; i < nSteps ; i++) {
				float sample = texture2DLod(gdepth, textCoord,1).r;
				gr += sample;
				textCoord -= deltaTextCoord;
				}
			gr *= 2.0-eBS;
			gr = exposure*(gr/nSteps)*(1.0 - weatherval*0.8)*illuminationDecay;
			gr*= (1-isEyeInWater)*(1+centerdist*3)/(8*(2-transition_fading+night))*(0.6+0.4*tB);
			color.rgb += max(gr*lightColor*Godrays_Strength,vec3(0.0));
			}
		
	#endif
	
	#ifdef VL
	float vl = texture2DLod(gdepth, texcoord.xy,2).r;
	
	vec3 vlcol = getVLGradient(fragpos.xyz);
	vec3 lightColor = (sunlight*16*sunVisibility+moonlight*256*moonVisibility);
	vlcol = mix(lightColor*(1.0-eBS),vlcol + (vlcol*vlcol - 0.008)*0.7*(1-night),pow(eBS,0.1));
	vlcol = vlcol * (1.0 + (7.0-5.0*eBS)*weatherval);
	
	color.rgb = mix(color.rgb,vlcol*VL_Strength,vl*0.25);
	#endif
	}

	float visiblesun = 0.0;
	float temp;
	float nb = 0;

//calculate sun occlusion (only on one pixel)
if (texcoord.x < 3.0*pw && texcoord.x < 3.0*ph) {
	for (int i = 0; i < 10;i++) {
		for (int j = 0; j < 10 ;j++) {
		temp = texture2D(gaux1,lightPos + vec2(pw*(i-5.0)*10.0,ph*(j-5.0)*10.0)).g;
		visiblesun +=  1.0-float(temp > 0.04) ;
		nb += 1;
		}
	}
	visiblesun /= nb;

}
color.rgb = clamp(pow(color.rgb/MAX_COLOR_RANGE,vec3(1.0/2.2)),vec3(0.0),vec3(1.0));

/* DRAWBUFFERS:5 */
	gl_FragData[0] = vec4(color.rgb,visiblesun);
}
