#version 120

#define MAX_COLOR_RANGE 48.0
/*
!! DO NOT REMOVE !!
BSL Shaders is derived from Chocapic13 v5 test 2

This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/

/*
Disable an effect by putting "//" before "#define" when there is no number after
You can tweak the numbers, the impact on the shaders is self-explained in the variable's name or in a comment
*/

//ADJUSTABLE VARIABLES//
	
	#define WorldDimension 0								//The world dimension you're in. -1 : Nether | 0 : Overworld | 1 : End [0 -1 1]
	#define Blur_Distance 8									//Set distant blur starting point. Insert Minecraft's render distance here for best result. [2 4 6 8 10 12 14 16]
	
	#define Weather 										//Enables rain and snow.
		#define Weather_Opacity 0.4							//Set opacity of rain and snow [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]

	//#define DynaWeather									//Enable dynamic weather.
		#define DynaWeather_Strength 0.4					//Change dynamic weather's transition range. [0.1 0.2 0.3 0.4 0.5 0.6]
		#define DynaWeather_Speed 1.0						//Change dynamic weather's transition speed. [0.25 0.5 1.0 2.0 4.0 8.0 16.0]
	
	#define Vignette										//Darkens display corners.
		#define Vignette_Strength 0.8						//Set how dark the vignette will be. [0.2 0.4 0.6 0.8 1.0]
		#define Vignette_Start 0.0							//Distance from the center of the screen where the vignette effect start. [0.0 0.2 0.4 0.6]
		#define Vignette_End 1.5							//Distance from the center of the screen where the vignette effect end. [1.5 1.3 1.1 0.9]
	
	#define LensEffect										//Creates lens effects.
		#define LensEffect_Sun								//Enables lens effects during day time.
		#define LensEffect_Moon								//Enables lens effects during night time.
		#define LensEffect_Flare							//Enables lens flare effect. 
		//#define LensEffect_Dirt							//Enables dirty lens effect. Requires Bloom. Reduces gameplay visibility.
		//#define LensEffect_Rain							//Enables rain drop effect.
		#define Lens_Strength 1.0							//Visibility of lens effects. [0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0]

	#define Bloom											//Makes glow effect on bright stuffs.
		#define Bloom_Strength 1.00							//Set bloom strength. [0.25 0.5 0.75 1.00 1.25 1.50 1.75 2.0 2.25 2.50]
	
	//#define DOFv2											//Enables blur effect with mixing method.
		#define DOFv2_NormalDOF								//Blurs non-focused objects.
		//#define DOFv2_Bokeh								//Enables high quality DoF at bright spots for cinematic purpose.
		#define DOFv2_FogBlur								//Blurs everything far away.
		#define DOFv2_Strength 16							//Set focus strength. [4 8 12 16 20 24 28 32 36 40 44 48 52 56 60 64]
		#define DOFv2_BSide 6								//Set inner ring sample. [6 8 10]
		#define DOFv2_BDepth 4								//Set number of loops for bokeh. [4 6 8]
		#define DOFv2_BNGon 30								//Set bokeh shape as n-gon [3 4 5 6 7 8 12 30]
		#define DOFv2_BCurve 1.0							//Set bokeh curvature. Lower value gives circular shape, higher value gives star shape. [0.25 0.5 0.75 1.0 2.0 3.0 4.0]
		#define DOFv2_BRotate 0								//Set bokeh rotation [-60 -55 -50 -45 -40 -35 -30 -25 -20 -15 -10 -5 0 5 10 15 20 25 30 35 40 45 50 55 60]
		
	//#define ChromaticA									//Enable channel splitting for Depth of Field.
		#define ChromaticA_Strength 1.0						//Set global offset strength. [0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.0]
		#define ChromaticA_R_S	1.00						//Set offset strength for red channel. [0.00 0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]
		#define ChromaticA_R_R  180							//Set offset angle for red channel [0 15 30 45 60 75 90 105 120 135 150 165 180 195 210 225 240 255 270 285 300 315 330 345]
		#define ChromaticA_G_S	0.00						//Set offset strength for green channel. [0.00 0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]
		#define ChromaticA_G_R  90							//Set offset angle for green channel [0 15 30 45 60 75 90 105 120 135 150 165 180 195 210 225 240 255 270 285 300 315 330 345]
		#define ChromaticA_B_S	1.00						//Set offset strength for blue channel. [0.00 0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]
		#define ChromaticA_B_R  0							//Set offset angle for blue channel [0 15 30 45 60 75 90 105 120 135 150 165 180 195 210 225 240 255 270 285 300 315 330 345]

	//#define MotionBlur									//Sweeps screen when looking/moving too fast.
		#define MotionBlur_Pass 8							//Set how smooth the blur is. [4 8 16]
		#define MotionBlur_Strength 0.12					//Set blur strength. [0.06 0.12 0.18 0.24]
		//#define MotionBlur_Inverse						//Invert motion blur direction.
	
	//#define ColorGrading									//Darkens color by maximal value and brightens color by minimal value.
		//#define ColorGrading_LUT							//Shows lookup table. Color Process must be enabled first.
		
		#define ColR1 255.0									//Maximal red value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColG1 0.0									//Maximal green value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColB1 0.0									//Maximal blue value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColS1 1.0									//Red channel strength value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		#define ColM1 0.0									//Minimal red value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColC1 1.0									//Red channel curve value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		
		#define ColR2 0.0									//Maximal red value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColG2 255.0									//Maximal green value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColB2 0.0									//Maximal blue value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColS2 1.0									//Green channel strength value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		#define ColM2 0.0									//Minimal green value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColC2 1.0									//Green channel curve value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		
		#define ColR3 0.0									//Maximal red value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColG3 0.0									//Maximal green value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColB3 255.0									//Maximal blue value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColS3 1.0									//Blue channel strength value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		#define ColM3 0.0									//Minimal blue value. [0.0 16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 255.0]
		#define ColC3 1.0									//Blue channel curve value. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
		
	//#define Posterize										//Converts color gradient to fewer tones.
		#define Posterize_Limit 8							//Set number of tones available for a color. [2 4 8 16 32]
	//#define Scanline										//Adds scanline.
		#define Scanline_Strength 0.5						//Set scanline strength. [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]
	//#define Dithering										//Limits color pallete by reducing colors used.
		#define Dithering_Samples 16						//Set how much color used in dithering. Higher value costs more performance. [2 4 8 16 32 64]
		
	#define BandingFix										//Enable if you're using render quality 1x or below. Enabling this with higher quality may give some artifacts.
	
	//#define WorldTimeAnimation
	#define AnimationSpeed 1.0								//Set shader's speed. [0.1 0.25 0.5 0.75 1.0 2.0 3.0 4.0]
	
	#define Color_Brightness 1.15							//Set color brightness value. [0.70 0.75 0.80 0.85 0.90 0.95 1.00 1.05 1.10 1.15 1.20 1.25 1.30]
	#define Color_Saturation 0.94							//Set color saturation value. [0.80 0.82 0.84 0.86 0.88 0.90 0.92 0.94 0.96 0.98 1.00 1.02 1.04 1.06 1.08 1.10 1.12 1.14 1.16 1.18 1.20]
	
//TONEMAP		
float A = 1.0;		//brightness multiplier
float B = 0.37;		//black level (lower means darker and more constrasted, higher make the image whiter and less constrasted)
float C = 0.1;		//constrast level 
float D = 0.2;		
float E = 0.02;
float F = 0.3;
float W = MAX_COLOR_RANGE;
	
//ADJUSTABLE VARIABLES//



varying vec4 texcoord;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;

#ifdef DOFv2
uniform float centerDepthSmooth;
#endif

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

uniform sampler2D gaux1;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
#ifdef MotionBlur
uniform sampler2D depthtex2;
#endif
uniform sampler2D noisetex;
uniform sampler2D gaux2;
#ifdef Weather
uniform sampler2D gaux4;
#endif
uniform sampler2D composite;

uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;

uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;
uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float frameTimeCounter;
uniform int fogMode;

vec3 sunPos = sunPosition;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float timefract = worldTime;
float dimread = WorldDimension;
float eBS = eyeBrightnessSmooth.y/240.0;

//World Time Animation
#ifdef WorldTimeAnimation
float frametime = worldTime/20.0*AnimationSpeed;
#else
float frametime = frameTimeCounter*AnimationSpeed;
#endif

#ifdef DynaWeather
float dynaweather = max(pow((sin(frametime*0.07*DynaWeather_Speed)*0.25+cos(frametime*0.03*DynaWeather_Speed+6)*0.25+0.5),1.5)*(DynaWeather_Strength+0.1)-0.1,0.0);
#else
float dynaweather = 0.0;
#endif
float weatherval = mix(rainStrength,1.0,dynaweather);

// Standard depth function.
float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

float luma(vec3 color) {
	return dot(color,vec3(0.299, 0.587, 0.114));
}

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}

vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}

vec2 angleToVec2(float angle, float pi){
	return vec2(cos(angle*pi/180),sin(angle*pi/180));
}

vec3 Uncharted2Tonemap(vec3 x) {
	return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}

float distratio(vec2 pos, vec2 pos2) {
	float xvect = pos.x*aspectRatio-pos2.x*aspectRatio;
	float yvect = pos.y-pos2.y;
	return sqrt(xvect*xvect + yvect*yvect);
}
								
float gen_circular_lens(vec2 center, float size) {
	float dist=distratio(center,texcoord.xy)/size;
	return exp(-dist*dist);
}

vec2 noisepattern(vec2 pos) {
	return vec2(abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f)),abs(fract(sin(dot(pos.yx ,vec2(18.9898f,28.633f))) * 4378.5453f)));
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));
}

float distratio(vec2 pos, vec2 pos2, float ratio) {
	float xvect = pos.x*ratio-pos2.x*ratio;
	float yvect = pos.y-pos2.y;
	return sqrt(xvect*xvect + yvect*yvect);
}

float yDistAxis (in float degrees) {
	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		 tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 lightPos = tpos.xy/tpos.z;
		 lightPos = (lightPos + 1.0f)/2.0f;
		 
	return abs((lightPos.y-lightPos.x*(degrees))-(texcoord.y-texcoord.x*(degrees)));
	
}

float smoothCircleDist (in float lensDist) {
		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		 tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 lightPos = tpos.xy/tpos.z*lensDist;
		 lightPos = (lightPos + 1.0f)/2.0f;
		 
	return distratio(lightPos.xy, texcoord.xy, aspectRatio);
	
}

float circleDist (float lensDist, float size) {

	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		 tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 lightPos = tpos.xy/tpos.z*lensDist;
		 lightPos = (lightPos + 1.0f)/2.0f;
		 
	return pow(min(distratio(lightPos.xy, texcoord.xy, aspectRatio),size)/size,10.);
}

float makeCircle (vec2 coord, float size){
	float x = length((texcoord.xy - coord)*vec2(aspectRatio,1.0))/size;
	return max((1-pow(x,3.0))*(0.3+0.7*pow(x,2.0)),0.0)*pow(size*25.0,2.0)*4.0;
}

vec2 getRandomPosition (float seed){
	return vec2(sin(seed+cos(seed)*100),cos(seed+sin(seed)*100))*0.45+0.5;
}

float getRandomSize (float seed){
	return sin(seed*1.5+cos(seed)*75)*0.005+0.03;
}

vec3 alphablend(vec3 c, vec3 ac, float a) {
vec3 n_ac = normalize(ac)*(1/sqrt(3.));
vec3 nc = sqrt(c*n_ac);
return mix(c,nc,a);
}
float smStep (float edge0,float edge1,float x) {
float t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
return t * t * (3.0 - 2.0 * t);
}

float find_closest(vec2 pos)
{
	const int ditherPattern[64] = int[64](
		0, 32, 8, 40, 2, 34, 10, 42,
		48, 16, 56, 24, 50, 18, 58, 26,
		12, 44, 4, 36, 14, 46, 6, 38,
		60, 28, 52, 20, 62, 30, 54, 22,
		3, 35, 11, 43, 1, 33, 9, 41,
		51, 19, 59, 27, 49, 17, 57, 25,
		15, 47, 7, 39, 13, 45, 5, 37,
		63, 31, 55, 23, 61, 29, 53, 21);

    vec2 positon = floor(mod(vec2(texcoord.s * viewWidth,texcoord.t * viewHeight), 8.0f));
	int dither = ditherPattern[int(positon.x) + int(positon.y) * 8];
	
	return float(dither)/64.0;
}

//////////////////////////////VOID MAIN//////////////////////////////

void main() {

	const float pi = 22.0/7.0;
	float rainlens = 0.0;
	const float lifetime = 4.0;		//water drop lifetime in seconds
	float ftime = frametime*2.0/lifetime;  
	vec2 drop = vec2(0.0,fract(frametime/10.0));
	
	#ifdef LensEffect
	#ifdef LensEffect_Rain
	if (weatherval > 0.02) {
		float gen = 1.0-fract((ftime+0.5)*0.5);
		vec2 pos = (noisepattern(vec2(-0.94386347*floor(ftime*0.5+1.0),floor(ftime*0.5+1.0))))*0.8+0.1 - drop;
		rainlens += gen_circular_lens(fract(pos),0.04)*gen*weatherval;

		gen = 1.0-fract((ftime+1.0)*0.5);
		pos = (noisepattern(vec2(0.9347*floor(ftime*0.5+0.5),-1.033282*floor(ftime*0.5+0.5))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.023)*gen*weatherval;

		gen = 1.0-fract((ftime+1.5)*0.5);
		pos = (noisepattern(vec2(0.785282*floor(ftime*0.5+0.75),-0.285282*floor(ftime*0.5+0.75))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.03)*gen*weatherval;

		gen =  1.0-fract(ftime*0.5);
		pos = (noisepattern(vec2(-0.347*floor(ftime*0.5),0.6847*floor(ftime*0.5))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.05)*gen*weatherval;
	
		rainlens *= clamp((eyeBrightnessSmooth.y-220.0)/15.0,0.0,1.0);
	}
	#endif
	#endif
	
	vec2 fake_refract = (texture2D(noisetex,(texcoord.xy+frameTimeCounter/32)/32*vec2(1.0,aspectRatio)).xy-texture2D(noisetex,(texcoord.xy+frameTimeCounter/32)/24*vec2(1.0,aspectRatio)).xy)*1.5;
	vec2 newTC = texcoord.st + fake_refract * 0.01 * (rainlens*2+isEyeInWater*0.25);
	if (newTC.x < pw || newTC.x > 1.0-pw || newTC.y < ph || newTC.y > 1.0-ph) newTC = texcoord.xy;
	
	vec3 color = pow(texture2D(gaux2, newTC).rgb,vec3(2.2))*MAX_COLOR_RANGE;
	vec3 aux = texture2D(gaux1, newTC).rgb;
	
	float hand  = float(aux.g > 0.78 && aux.g < 0.82);
	float land = float(aux.g > 0.04);
	
	float fogrange = ((Blur_Distance*(6.0-3.0*weatherval))/(1+weatherval*eBS)*(1-isEyeInWater) + isEyeInWater);
	float fogfade = 96.0*(Blur_Distance*(1-isEyeInWater)+2.0*isEyeInWater);
	//if (dimread == -1 || dimread == 1) fogrange *= 2;
	float depthtx = 0.0;
	if (isEyeInWater == 0) depthtx = texture2D(depthtex0,newTC.xy).x;
	else depthtx = texture2D(depthtex1,newTC.xy).x;
	vec3 wpos  = nvec3(gbufferProjectionInverse * nvec4(vec3(newTC.xy,depthtx) * 2.0 - 1.0));	
	float fog = max((length(wpos)-fogrange)/fogfade,0.0);

	float doBloom = 0.0;
	#ifdef Bloom
	doBloom = 1.0;
	#endif
	#ifdef DOFv2
	doBloom = 1.0;
	#endif
	
	vec3 blur = vec3(0);
	vec3 blur1 = vec3(0);
	const float bpow = 0.25;
if (doBloom > 0.9){
	vec2 bloomcoord = newTC.xy;

		 blur1 = pow(texture2D(composite,bloomcoord/pow(2.0,2.0) + vec2(0.0,0.0)).rgb,vec3(2.2))*pow(7.0,bpow);
	vec3 blur2 = pow(texture2D(composite,bloomcoord/pow(2.0,3.0) + vec2(0.3,0.0)).rgb,vec3(2.2))*pow(6.0,bpow);
	vec3 blur3 = pow(texture2D(composite,bloomcoord/pow(2.0,4.0) + vec2(0.0,0.3)).rgb,vec3(2.2))*pow(5.0,bpow);
	vec3 blur4 = pow(texture2D(composite,bloomcoord/pow(2.0,5.0) + vec2(0.1,0.3)).rgb,vec3(2.2))*pow(4.0,bpow);
	vec3 blur5 = pow(texture2D(composite,bloomcoord/pow(2.0,6.0) + vec2(0.2,0.3)).rgb,vec3(2.2))*pow(3.0,bpow);
	vec3 blur6 = pow(texture2D(composite,bloomcoord/pow(2.0,7.0) + vec2(0.3,0.3)).rgb,vec3(2.2))*pow(2.0,bpow);
	
	blur = (blur1 + blur2 + blur3 + blur4 + blur5 + blur6)*MAX_COLOR_RANGE;
	//blur = blur*pow(length(blur),0.4);
	//blur = pow(texture2D(composite,bloomcoord/2).rgb,vec3(2.2));
}

#ifdef DOFv2
	float pcoc = 0;
	
	vec3 blurcol = clamp(mix(blur1*MAX_COLOR_RANGE/1.75,blur/8.606,weatherval*pow(eBS,2.2))*0.44,vec3(0.0),vec3(2.2));
	float fbmix = 0.0;
	float nbmix = 0.0;
	
	#ifdef DOFv2_FogBlur
	fbmix = clamp(fog*8.0*(1.0+weatherval*0.2),0.0,1.0)*(mix(land,1.0,isEyeInWater)*(1-weatherval)+weatherval);
	if (fbmix > 0.001) color = mix(color,blurcol,fbmix);
	#endif
	
	#ifdef DOFv2_NormalDOF
	float z = texture2D(depthtex1, newTC.st).r;
	
	float focus = centerDepthSmooth;
	pcoc = clamp(abs(z-focus)/(128/DOFv2_Strength*(1.0+0.5*weatherval*eBS))-0.1/1280,0,0.00625);
	//pcoc -= hand*0.0005;
	
	pcoc = pcoc*(1-hand);
	
	nbmix = pcoc/(0.00625);
	float bbmix = max(nbmix,fbmix);
	if (bbmix > 0.001) color = mix(color,blurcol,nbmix);
	
	#ifdef DOFv2_Bokeh
	vec3 bokehcol = pow(texture2DLod(gaux2, newTC.xy,1).rgb,vec3(2.2));
	vec3 bokeht = vec3(0);
	float bpcoc = max(pcoc,fbmix*0.00125);
	float rprogress = 90.0;
    float sprogress = 1.0/float(DOFv2_BDepth);
	float rloops = DOFv2_BSide;
	float dsamples = 1.0;
	
	#ifdef ChromaticA
	vec2 offset_r = (angleToVec2(ChromaticA_R_R,pi)*ChromaticA_R_S*ChromaticA_Strength*vec2(1.0,aspectRatio))*bpcoc*0.7;
	vec2 offset_g = (angleToVec2(ChromaticA_G_R,pi)*ChromaticA_G_S*ChromaticA_Strength*vec2(1.0,aspectRatio))*bpcoc*0.7;
	vec2 offset_b = (angleToVec2(ChromaticA_B_R,pi)*ChromaticA_B_S*ChromaticA_Strength*vec2(1.0,aspectRatio))*bpcoc*0.7;
	#endif
    
    if (bpcoc > 0.00){
            for (int i = 0; i < DOFv2_BDepth; i++) {
                for (int j = 0; j < rloops; j++) {
				float sinval = abs(sin((rprogress-90.0+DOFv2_BRotate)*DOFv2_BNGon*0.5*pi/180));
				float cosval = mix(pow(cos(pi/DOFv2_BNGon),DOFv2_BCurve),1.0,pow(sinval,5.0));
                vec2 offsets = angleToVec2(rprogress,pi)*sprogress*cosval;
				offsets *= bpcoc*2.0*vec2(1.0,aspectRatio);
				#ifdef ChromaticA
				bokeht.r = pow(texture2DLod(gaux2, newTC.xy + offsets + offset_r,1.0).r,2.2)*pow(cosval,2.0);
				bokeht.g = pow(texture2DLod(gaux2, newTC.xy + offsets + offset_g,1.0).g,2.2)*pow(cosval,2.0);
				bokeht.b = pow(texture2DLod(gaux2, newTC.xy + offsets + offset_b,1.0).b,2.2)*pow(cosval,2.0);
				#else
                bokeht = pow(texture2DLod(gaux2, newTC.xy + offsets,1.0).rgb,vec3(2.2))*pow(cosval,2.0);
				#endif
                bokehcol += bokeht;
                rprogress += 360/rloops;
				if (texcoord.x > offsets.x && texcoord.y > offsets.y && texcoord.x < 1.0-offsets.x && texcoord.y < 1.0-offsets.y)dsamples += pow(cosval,2.0);
                }
            sprogress += 1.0/float(DOFv2_BDepth);
			rloops += DOFv2_BSide;
            }
            
        bokehcol /= (dsamples)/MAX_COLOR_RANGE;
        }
	bbmix *= pow(min(length(bokehcol),1.0),0.7);
	color = mix(color,bokehcol,bbmix);
	#endif
	
	#endif
	
	#ifdef Weather
	vec4 rain = pow(texture2D(gaux4,texcoord.xy),vec4(vec3(2.2),0.4));
	float raina = fbmix*(1-nbmix);
	if (raina > 0.003) color.rgb = mix(color.rgb,(color.rgb+0.025)*1.025,rain.a*(1-hand)*(Weather_Opacity*0.2+length(color.rgb)*4*Weather_Opacity)*raina);
	#endif
	
	pcoc = max(fbmix,nbmix);
#endif

#ifdef MotionBlur
	
	vec4 motionblur  = texture2D(depthtex2, newTC.st);
	vec3 mblur = pow(texture2D(gaux2,newTC.st).rgb,vec3(2.2))*MAX_COLOR_RANGE;
	float mbwg = 1.0;
	float mbm = 0.0;
	
	vec4 currentPosition = vec4(newTC.x * 2.0 - 1.0, newTC.y * 2.0 - 1.0, 2.0 * motionblur.x - 1.0, 1.0);
	
	vec4 fragposition = gbufferProjectionInverse * currentPosition;
	fragposition = gbufferModelViewInverse * fragposition;
	fragposition /= fragposition.w;
	fragposition.xyz += cameraPosition;
	
	vec4 previousPosition = fragposition;
	previousPosition.xyz -= previousCameraPosition;
	previousPosition = gbufferPreviousModelView * previousPosition;
	previousPosition = gbufferPreviousProjection * previousPosition;
	previousPosition /= previousPosition.w;

	vec2 velocity = (currentPosition - previousPosition).xy * MotionBlur_Strength / MotionBlur_Pass;
	float velocitylimit = MotionBlur_Strength*0.2;
	float mbnoise = texture2D(noisetex,texcoord.xy).r;
	velocity = normalize(velocity)*min(length(velocity),velocitylimit)*(1.0-2.0*mbnoise/MotionBlur_Pass);
	#ifdef MotionBlur_Inverse
	velocity *= -1;
	#endif

	vec2 coord = newTC.st + velocity;
	for (int i = 0; i < MotionBlur_Pass; ++i, coord += velocity) {
		if (hand < 0.9){
			vec3 temp = pow(texture2D(gaux2, coord).rgb,vec3(2.2))*MAX_COLOR_RANGE;
			if (coord.x < 0.0 || coord.x > 1.0) temp *= 4.0;
			if (coord.y < 0.0 || coord.y > 1.0) temp *= 4.0;
			mblur += temp;
			mbwg += 1.0;
		}
	}
	mblur /= mbwg;
	mblur = mix(color,mblur,mbwg/MotionBlur_Pass);

	float pcoc1 = 0.0;

	#ifdef DOFv2
	pcoc1 = max(pcoc,fog);
	#endif
	color = mix(mblur,color,pcoc1);

	//color = vec3(pcoc1);
	#endif
	
	float scanline = 0.0;
	#ifdef Scanline
	scanline = sin(texcoord.y*viewHeight*2.0+frametime*4);
	color *= 1+scanline*Scanline_Strength*0.1;
	#endif

	#ifdef Bloom
	float bmval = 0.003*7/pow(7,bpow)*(1+scanline*Scanline_Strength*0.2);
	color.rgb = mix(color,blur,bmval*Bloom_Strength);
	//color = blur*MAX_COLOR_RANGE*bmval;
	//color.rgb = blur5;
	#endif

	color.xyz = ((1-(1-color.xyz/48.0)*(1-(color.rgb/48.0)*sqrt(luma(color.rgb/48.0))))*48.0);

	#ifdef LensEffect_Rain
	vec3 c_rain = color*1.5;
	color = mix(color,c_rain,pow(rainlens,0.5)*weatherval);
	#endif
	
	//Tonemapping
	vec3 curr = Uncharted2Tonemap(color);
	vec3 whiteScale = 1.0f/Uncharted2Tonemap(vec3(W));
	color = curr*whiteScale;
		
	//Vignette
	float vignette = 1.0;
	#ifdef Vignette
	float len = length(texcoord.xy-vec2(.5));
	float len2 = distratio(texcoord.xy,vec2(.5));
	float dc = mix(len,len2,0.3);
    vignette = smStep(Vignette_End, Vignette_Start,  dc);
	
	color = mix(color,color*vignette,Vignette_Strength);
	#endif
	
	//Lens Flare
	#ifdef LensEffect
	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 lightPos = tpos.xy/tpos.z;
		lightPos = (lightPos + 1.0f)/2.0f;

    float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
	float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);

    float time = float(worldTime);
	float tB = pow(abs(sin(time/12000*22/7)),0.5);

    float sunvisibility = min(texture2D(gaux2,vec2(0.0)).a,1.0) * fading *(1-isEyeInWater);
	
	float truepos = sunPosition.z/abs(sunPosition.z);		//1 -> sun / -1 -> moon
	vec3 rainc = mix(vec3(1.),vec3(0.5),weatherval);
	vec3 lightColor = mix(pow(sunlight,vec3(0.25))*sunVisibility*rainc,moonlight*36.0*moonVisibility*rainc,truepos*0.5+0.5);
	
	float lensBrightness = 1.2*Lens_Strength;
	#ifndef LensEffect_Sun
	lensBrightness *= clamp(truepos,0.0,1.0);
	#endif
	#ifndef LensEffect_Moon
	lensBrightness *= clamp(-truepos,0.0,1.0);
	#endif
	
	float lens_strength = 0.0;
	vec3 lenscolor = vec3(1);
	float lensFlare = 0.0;
	
		// Dirty Lens
		#ifdef LensEffect_Dirt
		float dlstr = eBS*(1.0-moonVisibility*0.5);
		float dlensmask = pow(length(Uncharted2Tonemap(blur/MAX_COLOR_RANGE))*(0.8-0.4*dlstr),0.8+0.4*pow(dlstr,2.0))*(1.0-(0.1+0.6*sunVisibility)*dlstr*(1.0-weatherval*(1.0-dlstr*0.25)));
		dlensmask = max(dlensmask,pow(max(1.0-smoothCircleDist(1.0),0.0),5.0)*sunvisibility*(1.0-weatherval))*pow(vignette,2.2);
		float dlens = texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio)/16.0+1.0).r;
			  dlens+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio)/12.0+2.3).r;
			  dlens+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio)/8.0+3.45).r;
			  dlens+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio)/4.0+4.56).r;
			  dlens = dlens*0.5+2;
			  dlens = pow(dlens*0.25,1.2);
		
		float ddust = texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio)).r;
			  ddust+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio) + 1.1).r;
			  ddust+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio) + 2.2).r;
			  ddust+= texture2D(noisetex,texcoord.xy*vec2(1.0,1.0/aspectRatio) + 3.3).r;
			  
		float dcircle = 0;
		float seed = 16;
		for ( int i = 0; i < 30; i++) {
			dcircle += makeCircle(getRandomPosition(i+seed*30),getRandomSize(i+seed*30));
		}
		dcircle = min(dcircle,1.2);
		dcircle *= pow(0.7+dlensmask*0.3,2.0);
		
		float ddust2 = max(max(ddust-3.0,0.0)*32*pow(dlensmask,0.2)+pow(ddust/4.0,1.5)*0.5,0.0);
		
		lenscolor = (normalize(blur))*pow(length(blur),0.25);
		color = mix(color, dlens * lenscolor * lensBrightness,dlensmask*0.2);
		color += (ddust2+dcircle) * lenscolor * dlensmask * lensBrightness;
		
		#endif
		
	if (sunvisibility > 0.01) {	
		#ifdef LensEffect_Flare
		
		float lensFlare1 = 0.0;
		float lensFlare2 = 0.0;
		vec3 lenscol = vec3(0);
		//color = vec3(0);
		
		// Anamorphic Lens	
		float visibility = (1.0+3.0*tB)*pow(max(1.0-smoothCircleDist(1.0),0.0),3.0);
		
			
		lenscolor = length(lightColor)*mix(vec3(0.15, 0.4, 1),moonlight*16.0,truepos*0.4+0.4)*(1.0+truepos*0.5);

		lens_strength = 1.0 * lensBrightness * (0.8-truepos*0.2);
		lenscolor *= lens_strength;
		
		float anamorphic_lens = max(pow(max(1.0 - yDistAxis(0.0)/1.4,0.1),10.0),0.0);
		lenscol += anamorphic_lens * lenscolor * visibility  * sunvisibility * (1.0-weatherval*1.0);
		
		//Smooth Lens 1
		lenscolor =  mix(vec3(2.2, 0.4, 0.1),moonlight*16.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.2 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.2),0.1),20.0),0.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*6.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Smooth Lens 2
		lenscolor =  mix(vec3(2.2, 0.1, 0.05),moonlight*20.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.3 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.35),0.1),20.0),0.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*5.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Smooth Lens 3
		lenscolor =  mix(vec3(2.2, 0.4, 2.5),moonlight*24.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.4 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.5),0.1),20.0),0.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*4.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Smooth Lens 4
		lenscolor =  mix(vec3(1.8, 0.4, 2.5),moonlight*28.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.35 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.65),0.1),20.0),0.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*3.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Smooth Lens 5
		lenscolor =  mix(vec3(0.1, 0.2, 2.5),moonlight*32.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.3 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.8),0.1),20.0),0.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*2.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Multiplied Lens 1
		lenscolor = mix(vec3(2.5, 0.5, 0.3),moonlight*60.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.05 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - circleDist(-0.0, 0.14),0.1),5.0)-0.1,0.0);
		lensFlare2 = max(pow(max(1.0 - circleDist(-0.25, 0.14),0.1),5.0)-0.1,0.0);
		
		lensFlare = pow(clamp(lensFlare2 * lensFlare1, 0.0, 1.0),0.7);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*3.0,0.0,1.0),2.0);
		
		lenscol += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Multiplied Lens 2
		lenscolor = mix(vec3(1.8, 0.3, 1.4),moonlight*90.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.05 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - circleDist(-0.125, 0.12),0.1),5.0)-0.1,0.0);
		lensFlare2 = max(pow(max(1.0 - circleDist(-0.375, 0.12),0.1),5.0)-0.1,0.0);
		
		lensFlare = pow(clamp(lensFlare2 * lensFlare1, 0.0, 1.0),0.7);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*2.5,0.0,1.0),2.0);
		
		lenscol += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Multiplied Lens 3
		lenscolor = mix(vec3(1.0, 0.1, 2.5),moonlight*120.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.05 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - circleDist(-0.2, 0.13),0.1),5.0)-0.1,0.0);
		lensFlare2 = max(pow(max(1.0 - circleDist(-0.45, 0.13),0.1),5.0)-0.1,0.0);
		
		lensFlare = pow(clamp(lensFlare2 * lensFlare1, 0.0, 1.0),0.7);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*2.0,0.0,1.0),2.0);
		
		lenscol += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Point Lens 1
		lenscolor =  mix(vec3(2.5, 0.6, 0.6),moonlight*60.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.8 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = pow(min(pow(max(1.0 - smoothCircleDist(-0.425),0.1),50.0),0.5)*2.0,2.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*4.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Point Lens 2
		lenscolor =  mix(vec3(0.2, 0.6, 2.5),moonlight*60.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 0.9 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = pow(min(pow(max(1.0 - smoothCircleDist(-0.6),0.1),120.0),0.5)*2.0,2.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*4.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Point Lens 3
		lenscolor =  mix(vec3(0.7, 1.1, 3.0),moonlight*60.0,truepos*0.4+0.4) * lightColor;
		
		lens_strength = 1.0 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = pow(min(pow(max(1.0 - smoothCircleDist(-0.675),0.1),80.0),0.5)*2.0,2.0);
		
		lensFlare = clamp(lensFlare1, 0.0, 1.0);
		lensFlare *= pow(clamp(smoothCircleDist(1.0)*4.0,0.0,1.0),2.0);
		
		lenscol += lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Ring Lens 1
		lenscolor = mix(vec3(0.1, 0.35, 2.5),moonlight*75.0,truepos*0.4+0.4) * length(lightColor);
		
		lens_strength = 0.5 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - circleDist(-0.43, 0.2),0.1),5.0)-0.1,0.0);
		lensFlare2 = max(pow(max(1.0 - circleDist(-0.47, 0.2),0.1),5.0)-0.1,0.0);
		
		lensFlare = pow(clamp(lensFlare2 - lensFlare1, 0.0, 1.0),0.7)*0.8;
		lenscol += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		
		//Ring Lens 2
		lenscolor = mix(vec3(0.15, 0.4, 2.55),moonlight*45.0,truepos*0.4+0.4) * length(lightColor);
		
		lens_strength = 6.0 * lensBrightness;
		lenscolor *= lens_strength;
		
		lensFlare1 = max(pow(max(1.0 - circleDist(-0.89, 0.125),0.1),5.0)-0.1,0.0);
		lensFlare2 = max(pow(max(1.0 - circleDist(-0.9, 0.125),0.1),5.0)-0.1,0.0);
		
		lensFlare = pow(clamp(lensFlare2 - lensFlare1, 0.0, 1.0),0.7)*0.8;
		lenscol += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-weatherval*1.0);
		color = color + lenscol*(1-length(color)*0.5);
		#endif
	}
	#endif
	
	#ifdef Posterize
	color = pow(color,vec3(1.0/2.2));
	if (length(color) < 0.5)color = floor(normalize(color)*Posterize_Limit*2.0)/Posterize_Limit/2.0*floor(length(color*Posterize_Limit))/Posterize_Limit;
	if (length(color) > 0.5)color = ceil(normalize(color)*Posterize_Limit*2.0)/Posterize_Limit/2.0*ceil(length(color*Posterize_Limit))/Posterize_Limit;
	color = pow(color,vec3(2.2));
	#endif
	
	#ifdef Dithering
	float dither = find_closest(texcoord.xy);
	color = pow(color,vec3(1.0/2.2));
	color.r = floor(color.r*Dithering_Samples+dither)/Dithering_Samples;
	color.g = floor(color.g*Dithering_Samples+dither)/Dithering_Samples;
	color.b = floor(color.b*Dithering_Samples+dither)/Dithering_Samples;
	color = pow(color,vec3(2.2));
	#endif
	
	#ifdef Scanline
	color *= 1+scanline*Scanline_Strength*0.1;
	#endif
	
	#ifdef ColorGrading
		#ifdef ColorGrading_LUT
		if (texcoord.x < 256*pw && texcoord.y > 1-16*ph){
			color *= 0;
			color.r = (texcoord.x*viewWidth/16-floor(texcoord.x*viewWidth/16));
			color.g = (1-texcoord.y)*viewHeight/16;
			color.b = floor(texcoord.x*viewWidth/16)/16;
			color = pow(color,vec3(2.2));
		}
		#endif
	vec3 cpcol = (pow(color.r,ColC1)*pow(vec3(ColR1,ColG1,ColB1)/255.0,vec3(2.2))+pow(color.g,ColC2)*pow(vec3(ColR2,ColG2,ColB2)/255.0,vec3(2.2))+pow(color.b,ColC3)*pow(vec3(ColR3,ColG3,ColB3)/255.0,vec3(2.2)));
	vec3 cpmin = pow(vec3(ColM1,ColM2,ColM3)/255.0,vec3(2.2));
	color = (cpcol*(1-cpmin)+cpmin)*vec3(ColS1,ColS2,ColS3);
	#endif
	color = color*1.15*Color_Brightness;
	color = color*(Color_Saturation)-(color.r+color.g+color.b)/3*(Color_Saturation-1);
	
	color = clamp(pow(color,vec3(1.0/2.2)),0.0,1.0);
	
	#ifdef BandingFix
	color += (find_closest(texcoord.xy)-0.5)/255.0;
	#endif
	
	gl_FragColor = vec4(color,1.0);
}

